/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or
 * redistribute the software under the terms of the CeCILL license as
 * circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * As a counterpart to the access to the source code and rights to copy, modify
 * and redistribute granted by the license, users are provided only with a
 * limited warranty and the software's author, the holder of the economic
 * rights, and the successive licensors have only limited liability. In this
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally,
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.scolarix.serveur.components.modules;

import org.cocktail.fwkcktlpersonne.common.metier.EODepartement;
import org.cocktail.fwkcktlpersonne.common.metier.EOPays;
import org.cocktail.scolarix.serveur.components.controleurs.CtrlDernierEtablissement;
import org.cocktail.scolarix.serveur.exception.EtudiantException;
import org.cocktail.scolarix.serveur.finder.FinderDepartement;
import org.cocktail.scolarix.serveur.interfaces.IEtudiant;
import org.cocktail.scolarix.serveur.metier.eos.EODiplomePrepare;
import org.cocktail.scolarix.serveur.metier.eos.EORne;
import org.cocktail.scolarix.serveur.metier.eos.EOSituationScol;
import org.cocktail.scolarix.serveur.metier.eos.EOTypeClassePreparatoire;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;

// Generated by the WOLips Templateengine Plug-in at 28 mars 2008 16:46:44
public class DernierEtablissement_Cadre_G extends ModuleDossierAdministratif {
	
    private static final long serialVersionUID = 4820202953328342936L;

	public CtrlDernierEtablissement ctrl;

	public EORne unEtablissement;
	private String codeEtablissement;
	public EODepartement unDepartement;
	private String codeDepartement;
	public EOPays unPays;
	private String codePays;
	public EOSituationScol uneSituation;
	public EOTypeClassePreparatoire unTypeClassePrepa;
	public EODiplomePrepare unDiplomePrepare;
	private String codeSituation;

	public DernierEtablissement_Cadre_G(WOContext context) {
		super(context);
		ctrl = new CtrlDernierEtablissement(this, session().defaultEditingContext());
	}
	
	public String getContainerAllUpdateId() {
		return getComponentId() + "_containerAllUpdateId";
	}
	
	public String getContainerEtablissementId() {
		return getComponentId() + "_containerEtablissementId";
	}
	
	public void reset() {
		setCodePays(null);
		setCodeDepartement(null);
		setCodeEtablissement(null);
		setCodeSituation(null);
	}

	public WOComponent enregistrer() {
		super.enregistrer();
		return null;
	}

	public String disabledTFScript() {
		String disabledTFScript = "";
		if (etudiant() != null) {
			EOPays pays = historique().toFwkpers_Pays_DerEtab();
			if (pays != null) {
				if (pays.isPaysDefaut()) {
					disabledTFScript += "Field.enable($('CodeDepartement_DernierEtablissement_field'));";
					disabledTFScript += "Field.disable($('Etablissement_DernierEtablissement'));";
				}
				else {
					disabledTFScript += "Field.disable($('CodeDepartement_DernierEtablissement_field'));";
					disabledTFScript += "Field.enable($('Etablissement_DernierEtablissement'));";
				}
			}
			disabledTFScript += super.disabledTFScript();
		}
		return disabledTFScript;
	}

	public void validate() throws EtudiantException {
		IEtudiant etudiant = etudiant();
		if (etudiant == null) {
			throw new EtudiantException("Pas d'étudiant !!!");
		}
		etudiant.validateDernierEtablissement();
	}

	public String codeEtablissement() {
		if (codeEtablissement == null) {
			if (historique() != null && historique().toRneDerEtab() != null) {
				setCodeEtablissement(historique().toRneDerEtab().cRne());
			}
		}
		return codeEtablissement;
	}

	public void setCodeEtablissement(String codeEtablissement) {
		this.codeEtablissement = codeEtablissement;
	}

	public EORne etablissement() {
		return historique().toRneDerEtab();
	}

	public void setEtablissement(EORne etablissement) {
		historique().setToRneDerEtabRelationship(etablissement);
		if (etablissement != null) {
			setCodeEtablissement(etablissement.cRne());
			historique().setHistLibelleDerEtab(etablissement.llRne());
			if (etablissement.ville() != null) {
				historique().setHistVilleDerEtab(etablissement.ville());
			}
			if (etablissement.cRne() != null && etablissement.cRne().length() >= 3) {
				String cDepartement = etablissement.cRne().substring(0, 3);
				EODepartement departement = FinderDepartement.getDepartementByKey(edc(), cDepartement);
				if (departement != null) {
					setDepartement(departement);
					historique().setToFwkpers_Pays_DerEtabRelationship(EOPays.getPaysDefaut(edc()));
				}
			}
		} else {
			setCodeEtablissement(null);
			setHistLibelleDerEtab(null);
			setDepartement(null);
			setPays(null);
			historique().setHistVilleDerEtab(null);
		}
	}

	public String codeDepartement() {
		if (codeDepartement == null) {
			if (historique() != null) {
				EOPays pays = historique().toFwkpers_Pays_DerEtab();
				EODepartement departement = historique().toFwkpers_Departement_DerEtab();
				if (departement != null && pays != null && pays.isPaysDefaut()) {
					setCodeDepartement(departement.cDepartement());
				}
			}
		}
		return codeDepartement;
	}

	public void setCodeDepartement(String codeDepartement) {
		this.codeDepartement = codeDepartement;
	}

	public EODepartement departement() {
		return historique().toFwkpers_Departement_DerEtab();
	}

	public void setDepartement(EODepartement departement) {
		historique().setToFwkpers_Departement_DerEtabRelationship(departement);
		if (departement != null) {
			setCodeDepartement(departement.cDepartement());
		}
		else {
			setCodeDepartement(null);
		}
	}

	public String codePays() {
		if (codePays == null) {
			if (historique() != null && historique().toFwkpers_Pays_DerEtab() != null) {
				setCodePays(historique().toFwkpers_Pays_DerEtab().cPays());
			}
		}
		return codePays;
	}

	public void setCodePays(String codePays) {
		this.codePays = codePays;
	}

	public EOPays pays() {
		return historique().toFwkpers_Pays_DerEtab();
	}

	public void setPays(EOPays pays) {
		historique().setToFwkpers_Pays_DerEtabRelationship(pays);
		if (pays != null) {
			setCodePays(pays.cPays());
			if (pays.isPaysDefaut() == false) {
				setDepartement(null);
			}
		}
		else {
			setCodePays(null);
		}
	}

	public String histLibelleDerEtab() {
		return historique().histLibelleDerEtab();
	}

	public void setHistLibelleDerEtab(String histLibelleDerEtab) {
		historique().setHistLibelleDerEtab(histLibelleDerEtab);
	}

	public String codeSituation() {
		if (codeSituation == null) {
			if (historique() != null && historique().toSituationScol() != null) {
				setCodeSituation(historique().toSituationScol().situCode());
			}
		}
		return codeSituation;
	}

	public void setCodeSituation(String codeSituation) {
		this.codeSituation = codeSituation;
	}

	public EOSituationScol situation() {
		return historique().toSituationScol();
	}

	public void setSituation(EOSituationScol situation) {
		historique().setToSituationScolRelationship(situation);
		if (situation != null) {
			setCodeSituation(situation.situCode());
		}
		else {
			setCodeSituation(null);
		}
	}

	public String uneSituationDisplayString() {
		String situLibelle = uneSituation.situLibelle();
		return uneSituation.situCode() + " - " + situLibelle;
	}

	public String unTypeClassePrepaDisplayString() {
		return unTypeClassePrepa.tcpreCode() + " - " + unTypeClassePrepa.tcpreLibelle();
	}

	public String unDiplomePrepareDisplayString() {
		return unDiplomePrepare.dpreCode() + " - " + unDiplomePrepare.dpreLibelle();
	}

	public Integer histAnneeDerEtabPlusUn() {
		Integer histAnneeDerEtabPlusUn = historique().histAnneeDerEtab();

		if (histAnneeDerEtabPlusUn != null) {
			histAnneeDerEtabPlusUn = Integer.valueOf(histAnneeDerEtabPlusUn.intValue() + 1);
		}

		return histAnneeDerEtabPlusUn;
	}

	public boolean isEtablissementDernierEtablissementDisabled() {
		return pays() == null || pays().isPaysDefaut();
	}

	public boolean isCodeDepartementDernierEtablissementDisabled() {
		return disabled() || pays() == null || pays().isPaysDefaut() == false;
	}

	public Integer histAnneeDerEtab() {
		return historique().histAnneeDerEtab();
	}

	public void setHistAnneeDerEtab(Integer histAnneeDerEtab) {
		historique().setHistAnneeDerEtab(histAnneeDerEtab);
	}
	
	public boolean isCPGESelected() {
		boolean isCPGESelected = false;
		if (historique().toSituationScol() != null && historique().toSituationScol().situCode().equals(EOSituationScol.SITU_CODE_CPGE)) {
			isCPGESelected = true;
		}
		return isCPGESelected;
	}
	
}
